<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>MDEF | Andrea Bertran_Interface and application programming</title>
  <link rel="icon" type="image/png" href="images/favicomatic/favicon-32x32.png" sizes="32x32" />
  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="plugins/counto/animate.css">
  <link rel="stylesheet" href="plugins/aos/aos.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="css/style.css" rel="stylesheet">

</head>

<body>

<!-- Navigation Start -->
<!-- Header Start -->

<nav class="navbar navbar-expand-lg  main-nav " id="navbar">
    <div class="container">
	  <a class="navbar-brand" href="index.html">
	  	<img src="images/logo_2.png" alt="Image" style="width:170px"; class="img-fluid">
	  </a>


    <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
		<span class="ti-align-justify"></span>
	  </button>

  	  <div class="collapse navbar-collapse" id="navbarsExample09">
			<ul class="navbar-nav ml-auto">

      <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="dropdown01" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Info</a>
          <ul class="dropdown-menu" aria-labelledby="dropdown01">
            <li><a class="dropdown-item" href="about-me.html">About me</a></li>
            <li><a class="dropdown-item" href="contact.html">Contact</a></li>
            <li><a class="dropdown-item" href="https://www.dropbox.com/home/Portfolio?preview=2019.01_Portfolio+Andrea+Bertran.pdf" target="_blank" >Portfolio</a></li>
          </ul>
        </li>

        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">MDEF</a>
          <ul class="dropdown-menu" aria-labelledby="dropdown02">
            <li><a class="dropdown-item" href="term1.html">Term 1</a></li>
            <li><a class="dropdown-item" href="term2.html">Term 2</a></li>
            <li><a class="dropdown-item" href="term3.html">Term 3</a></li>
            <li><a class="dropdown-item" href="masterproject.html">Master's project</a></li>
          </ul>
        </li>

      </ul>
      </div>
  </div>
</nav>

<!-- Header Close -->


<!-- Body Open -->
<section class="page-title section pb-0">
  <div class="container">
    <div class="row">
      <div class="col-lg-12">

        <div class="text-left">
          <h2 class="mb-0 text-lg">'Interface and application programming'</h2>
          <span class="date text-sm">04.29.2020</span>
        </div>
      </div>
      </div>
    </div>
  </div>
 </div>
</section>

<section class="section portfolio-single">
	<div class="container">
		<div class="row justify-content-center">
			<div class="col-lg-12">
				<div class="project-info" align="justify">
          <p>
            For now, I've been working a lot with Processing and Arduino, and even though I'd like to try to use the ESP8266, I'll leave it for the upcoming weeks. Mainly because I got stuck with Processing, trying to figure out the reason why it continually gave me an error with the code. I spent a lot of time figuring out the best way possible to use the RGB Sensor.

            <br><br>

            To begin using the Adafruit Sensor, I needed to download the library. I went to their webpage and followed the instructions to download the library - <a target="_blank" href="https://learn.adafruit.com/adafruit-color-sensors/overview"><i>"Adafruit_TCS34725"</i></a>. Like many other libraries, I went into the menu in Arduino IDE, search for Sketch/Include Library / Manage Libraries, and searched for "Adafruit TCS34725." After installing the library. I needed to check if it worked correctly, so I ran it and printed the values to see if it was reading something. It did.

            <br><br>

            How accurate is it? The downloaded file in Arduino already had the code for Processing as a comment. One thing to highlight about it, is that it can't run with Processing 3+, only 1.5!!! So I had to download that version first and then try it, changed the Serial Port (to match it with the Arduino), and Run. The file opened a small window that showed the color read, and yes, it is not very accurate. When I put a black color on top of it, it showed more of a brownish-grey, and the white was sometimes a bit yellowish. Anyway, even with these errors, it worked. So it was time to try it with my code.

            <br><br>

            <a class="image">
            <img src="images/Term_03/Interface and app/0.JPG" alt="" style="width:545px" class="img-fluid">
            <a class="image">
            <img src="images/Term_03/Interface and app/1.JPG" alt="" style="width:545px" align="right" class="img-fluid"></a>

            <br><br>

            Here came the hard part. I wanted to use two sensors, the RGB and another, that could change parameters in the code. I decided to use the flex Sensor. Here, I decided to save some values that somehow disturbed my code in Arduino. So I kept the gamma table (which was created by PhilB and allowed to convert RGB colors to what humans see) as a separate library and then included it in the file as the others. After this, I added an extra variable, and established contact with it, calibrating and mapping te values given by it. But when opening the Serial Port, the values didn't print as expected. I had the flex sensor value, and then without any spacing, the RGB values.

            <br><br>

            I needed to read and analyze how the print function in the RGB Sensor, worked. I searched for examples on the internet and realized that it was easier to print a letter +: to separate the numbers. After doing it and changing the position of the RGB Sensor to follow the FlexSensor, the values started to appear right. First, the value given by the FlexSensor followed by the RGB. Now the problem was with Processing. It gave error every time I ran the code, didn't read the value from the sensor, and neither did it changed what I asked it. I cleared and rewrote the things I wanted as well as searched for solutions on the internet. I got it after a long, long, long while.

            <br><br>

            Still, I'd like to rethink how it's drawn, I tried changing the "v.normalize" and "v.multiply" (this I learned by watching Dan Shiffman's videos) but didn't get what wanted. I tried putting the flex sensor's values for the "v2" but didn't understand what wished to either.  For now, this is what I got. Maybe I could add more sensors, and according to the one that changes values, Processing could draw rectangles, and if I change the sensor, it could start drawing ellipses, lines, or whatever other things.
            <br><br>

            <video width="1110px" height="" controls>
              <source src="images/Term_03/Interface and app/videointerface.mp4" type="video/mp4">
              <source src="movie.ogg" type="video/ogg">
            </video>

            <br><br><br><br>

            <a class="image">
            <img src="images/Term_03/Interface and app/2.jpg" alt="" style="width:545px" class="img-fluid">
            <a class="image">
            <img src="images/Term_03/Interface and app/3.jpg" alt="" style="width:545px" align="right" class="img-fluid"></a>

            <br><br><br><br>

            Files: <ul>
              <li><a href="images/Term_03/Interface and app/Arduino.rar" download=""> <i>Arduino</i></a></li>
              <li><a href="images/Term_03/Interface and app/Processing.rar" download=""> <i>Processing</i></a>
              </li>
            </ul>


          </p>


<!-- Body Close -->
  <br></br>

        <div class="mt-5">
					<a href="2020.04.22_Output Devices.html" class="image">
          <img src="images/Izq.png" alt="" style="width:12px" class="img-fluid"></a>

					<a href="2020.05.06_Invention.html" class="image">
          <img src="images/Dcha.png" alt="" style="width:12px" align="right" class="img-fluid"></a>
				</div>

			</div>
		</div>
	</div>
</section>

<!-- Footer start -->
<section class="footer">
	<div class="container">
		<div class="row ">
			<div class="col-lg-6">
        <p class="mb-0"> Email. <a href="mailto:andrea.bertran@students.iaac.net"> <b>andrea.bertran@students.iaac.net</b> </a></p>
        ---
        <p class="mb-0">Copyrights © 2019. Designed & Developed by <a target="_blank" href="https://themefisher.com/"> <b>Themefisher</b> </a></p>
        <p class="mb-0">Copyrights © 2019. Owned and modified by <a target="_blank" href="https://fablabbcn.org/" > <b>Iaac-FablabBarcelona</b> </a></p>
			</div>
			<div class="col-lg-6">
				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
					<ul class="list-inline mb-0">
						<li class="list-inline-item"><a href="https://www.instagram.com/ablahh/" target="_blank"><i class="ti-instagram mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://twitter.com/andreablahh" target="_blank"><i class="ti-twitter mr-3"></i></a>
						</li>
            <li class="list-inline-item"><a href="https://ablahh.tumblr.com/" target="_blank"><i class="ti-tumblr mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://www.linkedin.com/in/andrea-bertran-l%C3%B3pez-57ba43126/" target="_blank"><i class="ti-linkedin mr-3"></i></a></li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</section>
<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
